<?php
/**********************************************************************
    Copyright (C) FrontAccounting, LLC.
	Released under the terms of the GNU General Public License, GPL, 
	as published by the Free Software Foundation, either version 3 
	of the License, or (at your option) any later version.
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  
    See the License here <http://www.gnu.org/licenses/gpl-3.0.html>.
***********************************************************************/
//-----------------------------------------------------------------------------
//
//	Entry/Modify Delivery Note against Sales Order
//
$page_security = 'SA_SALESDELIVERY';
$path_to_root = "..";

include_once($path_to_root . "/sales/includes/cart_class.inc");
include_once($path_to_root . "/includes/session.inc");
include_once($path_to_root . "/includes/data_checks.inc");
include_once($path_to_root . "/sales/includes/sales_db.inc");
include_once($path_to_root . "/sales/includes/sales_ui.inc");
include_once($path_to_root . "/reporting/includes/reporting.inc");
include_once($path_to_root . "/taxes/tax_calc.inc");
include_once($path_to_root . "/purchasing/includes/db/file_system_db.inc");
include_once($path_to_root . "/sales/includes/db/charges_db.inc");
include_once($path_to_root . "/purchasing/includes/db/charges_rate_per_db.inc");

$js = "";
if ($SysPrefs->use_popup_windows) {
	$js .= get_js_open_window(900, 500);
}
if (user_use_date_picker()) {
	$js .= get_js_date_picker();
}

if (isset($_GET['ModifyDelivery'])) {
	$_SESSION['page_title'] = sprintf(_("Modifying Delivery Note # %d."), $_GET['ModifyDelivery']);
	$help_context = "Modifying Delivery Note";
	processing_start();
} elseif (isset($_GET['OrderNumber'])) {
	$_SESSION['page_title'] = _($help_context = "Deliver Items for a Sales Order");
	processing_start();
}

page($_SESSION['page_title'], false, false, "", $js);

if (isset($_GET['AddedID'])) {
	$dispatch_no = $_GET['AddedID'];

	display_notification_centered(sprintf(_("Delivery # %d has been entered."),$dispatch_no));

	display_note(get_customer_trans_view_str(ST_CUSTDELIVERY, $dispatch_no, _("&View This Delivery")), 0, 1);

	display_note(print_document_link($dispatch_no, _("&Print Delivery Note"), true, ST_CUSTDELIVERY));
	display_note(print_document_link($dispatch_no, _("&Email Delivery Note"), true, ST_CUSTDELIVERY, false, "printlink", "", 1), 1, 1);
	display_note(print_document_link($dispatch_no, _("P&rint as Packing Slip"), true, ST_CUSTDELIVERY, false, "printlink", "", 0, 1));
	display_note(print_document_link($dispatch_no, _("E&mail as Packing Slip"), true, ST_CUSTDELIVERY, false, "printlink", "", 1, 1), 1);

	display_note(get_gl_view_str(13, $dispatch_no, _("View the GL Journal Entries for this Dispatch")),1);

	if (!isset($_GET['prepaid']))
		hyperlink_params("$path_to_root/sales/customer_invoice.php", _("Invoice This Delivery"), "DeliveryNumber=$dispatch_no");

	hyperlink_params("$path_to_root/sales/inquiry/sales_orders_view.php", _("Select Another Order For Dispatch"), "OutstandingOnly=1");

	display_footer_exit();

} elseif (isset($_GET['UpdatedID'])) {

	$delivery_no = $_GET['UpdatedID'];

	display_notification_centered(sprintf(_('Delivery Note # %d has been updated.'),$delivery_no));

	display_note(get_trans_view_str(ST_CUSTDELIVERY, $delivery_no, _("View this delivery")), 0, 1);

	display_note(print_document_link($delivery_no, _("&Print Delivery Note"), true, ST_CUSTDELIVERY));
	display_note(print_document_link($delivery_no, _("&Email Delivery Note"), true, ST_CUSTDELIVERY, false, "printlink", "", 1), 1, 1);
	display_note(print_document_link($delivery_no, _("P&rint as Packing Slip"), true, ST_CUSTDELIVERY, false, "printlink", "", 0, 1));
	display_note(print_document_link($delivery_no, _("E&mail as Packing Slip"), true, ST_CUSTDELIVERY, false, "printlink", "", 1, 1), 1);

	if (!isset($_GET['prepaid']))
		hyperlink_params($path_to_root . "/sales/customer_invoice.php", _("Confirm Delivery and Invoice"), "DeliveryNumber=$delivery_no");

	hyperlink_params($path_to_root . "/sales/inquiry/sales_deliveries_view.php", _("Select A Different Delivery"), "OutstandingOnly=1");

	display_footer_exit();
}
//-----------------------------------------------------------------------------

if (isset($_GET['OrderNumber']) && $_GET['OrderNumber'] > 0) {

	$ord = new Cart(ST_SALESORDER, $_GET['OrderNumber'], true);
	if ($ord->is_prepaid())
		check_deferred_income_act(_("You have to set Deferred Income Account in GL Setup to entry prepayment invoices."));

	if ($ord->count_items() == 0) {
		hyperlink_params($path_to_root . "/sales/inquiry/sales_orders_view.php",
			_("Select a different sales order to delivery"), "OutstandingOnly=1");
		echo "<br><center><b>" . _("This order has no items. There is nothing to delivery.") .
			"</center></b>";
		display_footer_exit();
	} else if (!$ord->is_released()) {
		hyperlink_params($path_to_root . "/sales/inquiry/sales_orders_view.php",_("Select a different sales order to delivery"),
			"OutstandingOnly=1");
		echo "<br><center><b>"._("This prepayment order is not yet ready for delivery due to insufficient amount received.")
			."</center></b>";
		display_footer_exit();
	}
 	// Adjust Shipping Charge based upon previous deliveries TAM
	adjust_shipping_charge($ord, $_GET['OrderNumber']);
 
	$_SESSION['Items'] = $ord;
	copy_from_cart();

} elseif (isset($_GET['ModifyDelivery']) && $_GET['ModifyDelivery'] > 0) {

	check_is_editable(ST_CUSTDELIVERY, $_GET['ModifyDelivery']);
	$_SESSION['Items'] = new Cart(ST_CUSTDELIVERY,$_GET['ModifyDelivery']);

	if (!$_SESSION['Items']->prepaid && $_SESSION['Items']->count_items() == 0) {
		hyperlink_params($path_to_root . "/sales/inquiry/sales_orders_view.php",
			_("Select a different delivery"), "OutstandingOnly=1");
		echo "<br><center><b>" . _("This delivery has all items invoiced. There is nothing to modify.") .
			"</center></b>";
		display_footer_exit();
	}

	copy_from_cart();
	
} elseif ( !processing_active() ) {
	/* This page can only be called with an order number for invoicing*/

	display_error(_("This page can only be opened if an order or delivery note has been selected. Please select it first."));

	hyperlink_params("$path_to_root/sales/inquiry/sales_orders_view.php", _("Select a Sales Order to Delivery"), "OutstandingOnly=1");

	end_page();
	exit;

} else {
	check_edit_conflicts(get_post('cart_id'));

	if (!check_quantities()) {
		display_error(_("Selected quantity cannot be less than quantity invoiced nor more than quantity	not dispatched on sales order."));

	} 
// 	elseif(!check_num('ChargeFreightCost', 0)) {
// 		display_error(_("Freight cost cannot be less than zero"));
// 		set_focus('ChargeFreightCost');
// 	}
}

//-----------------------------------------------------------------------------

function check_data()
{
	global $Refs, $SysPrefs;

	if (!isset($_POST['DispatchDate']) || !is_date($_POST['DispatchDate']))	{
		display_error(_("The entered date of delivery is invalid."));
		set_focus('DispatchDate');
		return false;
	}

	if (!is_date_in_fiscalyear($_POST['DispatchDate'])) {
		display_error(_("The entered date is out of fiscal year or is closed for further data entry."));
		set_focus('DispatchDate');
		return false;
	}

	if (!isset($_POST['due_date']) || !is_date($_POST['due_date']))	{
		display_error(_("The entered dead-line for invoice is invalid."));
		set_focus('due_date');
		return false;
	}

	if ($_SESSION['Items']->trans_no==0) {
		if (!$Refs->is_valid($_POST['ref'], ST_CUSTDELIVERY)) {
			display_error(_("You must enter a reference."));
			set_focus('ref');
			return false;
		}
	}
	if ($_POST['ChargeFreightCost'] == "") {
		$_POST['ChargeFreightCost'] = price_format(0);
	}

	if (!check_num('ChargeFreightCost',0)) {
		display_error(_("The entered shipping value is not numeric."));
		set_focus('ChargeFreightCost');
		return false;
	}

	if ($_SESSION['Items']->has_items_dispatch() == 0 && input_num('ChargeFreightCost') == 0) {
		display_error(_("There are no item quantities on this delivery note."));
		return false;
	}

	if (!check_quantities()) {
		return false;
	}

	copy_to_cart();

	if (!$SysPrefs->allow_negative_stock() && ($low_stock = $_SESSION['Items']->check_qoh()))
	{
		display_error(_("This document cannot be processed because there is insufficient quantity for items marked."));
		return false;
	}

	return true;
}
//------------------------------------------------------------------------------
function copy_to_cart()
{
	$cart = &$_SESSION['Items'];
	$cart->ship_via = $_POST['ship_via'];
	$cart->freight_cost = input_num('ChargeFreightCost');
	$cart->document_date = $_POST['DispatchDate'];
	$cart->due_date =  $_POST['due_date'];
	$cart->Location = $_POST['Location'];
	$cart->Comments = $_POST['Comments'];
	$cart->dimension_id = $_POST['dimension_id'];
	$cart->dimension2_id = $_POST['dimension2_id'];
	$cart->vehicle_no = $_POST['vehicle_no'];
	$cart->file_system =  $_SESSION['Items']->file_system;
	$cart->company_id =  $_SESSION['Items']->company_id;
	$cart->is_broker =  $_SESSION['Items']->is_broker;
	$cart->supplier_id =  $_SESSION['Items']->supplier_id;
	$cart->brokery_amt =  $_SESSION['Items']->brokery_amt;
	$cart->mode =  $_SESSION['Items']->mode;
	$cart->bags =  $_SESSION['Items']->bags;

	// $cart->sales_person = $_POST['sales_person'];

	if ($cart->trans_no == 0)
		$cart->reference = $_POST['ref'];

}
//------------------------------------------------------------------------------

function copy_from_cart()
{
	$cart = &$_SESSION['Items'];
	$_POST['ship_via'] = $cart->ship_via;
	$_POST['ChargeFreightCost'] = price_format($cart->freight_cost);
	$_POST['DispatchDate'] = $cart->document_date;
	$_POST['due_date'] = $cart->due_date;
	$_POST['Location'] = $cart->Location;
	$_POST['Comments'] = $cart->Comments;
	$_POST['dimension_id'] = $cart->dimension_id;
	$_POST['dimension2_id'] = $cart->dimension2_id;
	$_POST['sales_person'] = $cart->sales_person;
	$_POST['vehicle_no'] = $cart->vehicle_no;
	$_POST['file_system'] = $cart->file_system;
	$_POST['company_id'] = $cart->company_id;
	$_POST['cart_id'] = $cart->cart_id;
	$_POST['ref'] = $cart->reference;
	$_POST['is_broker'] = $cart->is_broker;
	$_POST['supplier_id'] = $cart->supplier_id;
	$_POST['brokery_amt'] = $cart->brokery_amt;
	$_POST['mode'] = $cart->mode;
	$_POST['bags'] = $cart->bags;
}
//------------------------------------------------------------------------------

function check_quantities()
{
	$ok =1;
	// Update cart delivery quantities/descriptions
	foreach ($_SESSION['Items']->line_items as $line=>$itm) {
		if (isset($_POST['Line'.$line])) {
			if($_SESSION['Items']->trans_no) {
				$min = $itm->qty_done;
				$max = $itm->quantity;
			} else {
				$min = 0;
				$max = $itm->quantity - $itm->qty_done;
			}

			if (check_num('Line'.$line, $min, $max)) {
				$_SESSION['Items']->line_items[$line]->qty_dispatched =
				  input_num('Line'.$line);
			} else {
				set_focus('Line'.$line);
				$ok = 0;
			}

		}

		if (isset($_POST['Line'.$line.'Desc'])) {
			$line_desc = $_POST['Line'.$line.'Desc'];
			if (strlen($line_desc) > 0) {
				$_SESSION['Items']->line_items[$line]->item_description = $line_desc;
			}
		}
	}
	return $ok;
}

//------------------------------------------------------------------------------

if (isset($_POST['process_delivery']) && check_data()) {
	$dn = &$_SESSION['Items'];

	if ($_POST['bo_policy']) {
		$bo_policy = 0;
	} else {
		$bo_policy = 1;
	}
	$newdelivery = ($dn->trans_no == 0);

	if ($newdelivery)
		new_doc_date($dn->document_date);

	$delivery_no = $dn->write($bo_policy);

	$result2 = get_charges(check_value('show_inactive'));
	$i = 1;
	while ($myrow2 = db_fetch($result2)){
		if($myrow2['is_negative']==1)
			$_POST['charges_amount'.$i] = input_num('charges_amount'.$i)*-1;
		if(input_num('charges_amount'.$i) != 0){
			$sql = "INSERT INTO ".TB_PREF."charges_trans (trans_no, type, charge_id, gl_code, name, charges_amount) VALUES (".db_escape($delivery_no) . ", ".db_escape(ST_CUSTDELIVERY) . ", ".db_escape($myrow2['id']) . ", ".db_escape($myrow2['gl_code']) . ", 
				".db_escape($myrow2['name']) . ", ".db_escape(input_num('charges_amount'.$i)) . ")";
   			db_query($sql,"The charges could not be added");
		}
			$i++;
	}

	if ($delivery_no == -1)
	{
		display_error(_("The entered reference is already in use."));
		set_focus('ref');
	}
	else
	{
		$is_prepaid = $dn->is_prepaid() ? "&prepaid=Yes" : '';

		processing_end();
		if ($newdelivery) {
			meta_forward($_SERVER['PHP_SELF'], "AddedID=$delivery_no$is_prepaid");
		} else {
			meta_forward($_SERVER['PHP_SELF'], "UpdatedID=$delivery_no$is_prepaid");
		}
	}
}

if (isset($_POST['Update']) || isset($_POST['_Location_update']) || isset($_POST['qty']) || isset($_POST['process_delivery']) || input_changed('DispatchDate')) {
	$Ajax->activate('Items');
}

$kv_batch = get_company_pref('kv_batch');
$kv_exp_date = get_company_pref('kv_exp_date');
//------------------------------------------------------------------------------
start_form();
hidden('cart_id');

start_table(TABLESTYLE2, "width='100%'", 5);
echo "<tr><td>"; // outer table

start_table(TABLESTYLE, "width='100%'");
start_row();
label_cells(_("Customer"), $_SESSION['Items']->customer_name, "class='tableheader2'");
label_cells(_("Branch"), get_branch_name($_SESSION['Items']->Branch), "class='tableheader2'");
label_cells(_("Currency"), $_SESSION['Items']->customer_currency, "class='tableheader2'");
end_row();
start_row();

if ($_SESSION['Items']->trans_no==0) {
	ref_cells(_("Reference"), 'ref', '', null, "class='tableheader2'", false, ST_CUSTDELIVERY,
	array('customer' => $_SESSION['Items']->customer_id,
			'branch' => $_SESSION['Items']->Branch,
			'date' => get_post('DispatchDate')));
} else {
	label_cells(_("Reference"), $_SESSION['Items']->reference, "class='tableheader2'");
}

label_cells(_("For Sales Order"), get_customer_trans_view_str(ST_SALESORDER, $_SESSION['Items']->order_no), "class='tableheader2'");

label_cells(_("Sales Type"), $_SESSION['Items']->sales_type_name, "class='tableheader2'");
end_row();
start_row();

if (!isset($_POST['Location'])) {
	$_POST['Location'] = $_SESSION['Items']->Location;
}
label_cell(_("Delivery From"), "class='tableheader2'");
locations_list_cells(null, 'Location', null, false, true);

if (!isset($_POST['ship_via'])) {
	$_POST['ship_via'] = $_SESSION['Items']->ship_via;
}
// label_cell(_("Shipping Company"), "class='tableheader2'");
// shippers_list_cells(null, 'ship_via', $_POST['ship_via']);
hidden('ship_via', 1);
// set this up here cuz it's used to calc qoh
if (!isset($_POST['DispatchDate']) || !is_date($_POST['DispatchDate'])) {
	$_POST['DispatchDate'] = new_doc_date();
	if (!is_date_in_fiscalyear($_POST['DispatchDate'])) {
		$_POST['DispatchDate'] = end_fiscalyear();
	}
}
date_cells(_("Date"), 'DispatchDate', '', $_SESSION['Items']->trans_no==0, 0, 0, 0, "class='tableheader2'",true);
label_cells(_("File System"), get_file_system_name($_SESSION['Items']->file_system) , "class='tableheader2'");
end_row();
// label_cell(_(""));
// label_cell(_(""));
// label_cell(_(""));
// label_cell(_(""));
// text_cells(_("Truck #").':', 'vehicle_no', $_POST['vehicle_no'],"","",false, "class='tableheader2'");
hidden('vehicle_no', 0);
label_cells(_("Company Name"), get_latter_hand_name($_SESSION['Items']->company_id) , "class='tableheader2'");

if($_SESSION['Items']->mode)
label_cells(_("Mode"), $_SESSION['Items']->mode, "class='tableheader2'");
if($_SESSION['Items']->bags)
label_cells(_("Bags"), $_SESSION['Items']->bags, "class='tableheader2'");
if($_SESSION['Items']->supplier_id)
label_cells(_("Broker"), get_supplier_name($_SESSION['Items']->supplier_id) , "class='tableheader2'");

start_row();
if($_SESSION['Items']->brokery_amt)
label_cells(_("Broker Amount"), $_SESSION['Items']->brokery_amt, "class='tableheader2'");
end_row();
end_table();

echo "</td><td>";// outer table

start_table(TABLESTYLE, "width='100%'");

if (!isset($_POST['due_date']) || !is_date($_POST['due_date'])) {
	$_POST['due_date'] = get_invoice_duedate($_SESSION['Items']->payment, $_POST['DispatchDate']);
}
customer_credit_row($_SESSION['Items']->customer_id, $_SESSION['Items']->credit, "class='tableheader2'");

$dim = get_company_pref('use_dimension');
if ($dim > 0) {
	start_row();
	label_cell(_($SysPrefs->prefs['dim1_name']), "class='tableheader2'");
	dimensions_list_cells(null, 'dimension_id', $_POST['dimension_id'], true, ' ', false, 1, false);
	end_row();
}		
else
	hidden('dimension_id', 0);
if ($dim > 1) {
	start_row();
	label_cell(_($SysPrefs->prefs['dim2_name']), "class='tableheader2'");
	dimensions_list_cells(null, 'dimension2_id',  $_POST['dimension2_id'], true, ' ', false, 2, false);
	end_row();
}		
else
	hidden('dimension2_id', 0);
//---------
start_row();
date_cells(_("Invoice Dead-line"), 'due_date', '', null, 0, 0, 0, "class='tableheader2'");
end_row();
if($_SESSION['Items']->sales_person)
{

	start_row();
    label_cells(_("Sales Person"), get_salesman_name($_SESSION['Items']->sales_person) , "class='tableheader2'");
	end_row();
}
end_table();

echo "</td></tr>";
end_table(1); // outer table

$row = get_customer_to_order($_SESSION['Items']->customer_id);
if ($row['dissallow_invoices'] == 1)
{
	display_error(_("The selected customer account is currently on hold. Please contact the credit control personnel to discuss."));
	end_form();
	end_page();
	exit();
}	



$ln_id = find_submit('_copy_line');
if ($ln_id != -1)
{
	// sales_order_set_template($ln_id, check_value('chgtpl'.$ln_id));

		// display_error(count($_SESSION['Items']->line_items)." count" ) ;
 		 // $n_line= count($_SESSION['Items']->line_items);
 		 // display_error($n_line);
 		 $line_array=array();
         $line_array = clone $_SESSION['Items']->line_items[$ln_id];
         $line_array->copy_line=$ln_id;
         $line_array->qty_done+=$_SESSION['Items']->line_items[$ln_id]->qty_dispatched;
         $line_array->qty_dispatched =  $line_array->quantity-$line_array->qty_done;
         array_push($_SESSION['Items']->line_items,$line_array);
         $_SESSION['Items']->line_items[$ln_id]->lock_line=1;
     
         unset($_POST['copy_line'.$ln_id]);
       	// $Ajax->activate('_page_body');
	// display_error($ln_id." in ");
	$Ajax->activate('Items');
}
	// print_r($_SESSION['Items']->line_items);
display_heading(_("Delivery Items"));
div_start('Items');
start_table(TABLESTYLE, "width='80%'");

$new = $_SESSION['Items']->trans_no==0;
$th = array(_("Item Code"), _("Item Description"), $new ? _("Ordered") : _("Max. delivery"), _("Units"),   $new ? _("Delivered") : _("Invoiced"), _("This Delivery"), _("Rate Type"), _("Rate"), _("Price"), _("Tax Type"), _("Discount"), _("Total"),_("Clone"));
	if($kv_exp_date){
		array_splice( $th, 4, 0, _("Batch No") );
		array_splice( $th, 5, 0, _("Exp Date") );
	}elseif($kv_batch)
		array_splice( $th, 4, 0, _("Batch No") );
	
table_header($th);
$k = 0;
$has_marked = false;
global $Ajax;
$lock_batch=array();
$line_qty_sum=0;
foreach ($_SESSION['Items']->line_items as $line=>$ln_itm) {
	if ($ln_itm->quantity==$ln_itm->qty_done) {
		continue; //this line is fully delivered
	}
	if(isset($_POST['_Location_update']) || isset($_POST['clear_quantity']) || isset($_POST['reset_quantity'])) {
		// reset quantity
		$ln_itm->qty_dispatched = $ln_itm->quantity-$ln_itm->qty_done;
	}
	// if it's a non-stock item (eg. service) don't show qoh
	$row_classes = null;
	if (has_stock_holding($ln_itm->mb_flag) && $ln_itm->qty_dispatched) {
		// It's a stock : call get_dispatchable_quantity hook  to get which quantity to preset in the
		// quantity input box. This allows for example a hook to modify the default quantity to what's dispatchable
		// (if there is not enough in hand), check at other location or other order people etc ...
		// This hook also returns a 'reason' (css classes) which can be used to theme the row.
		//
		// FIXME: hook_get_dispatchable definition does not allow qoh checks on transaction level
		// (but anyway dispatch is checked again later before transaction is saved)

		$qty = $ln_itm->qty_dispatched;
		if ($check = check_negative_stock($ln_itm->stock_id, $ln_itm->qty_done-$ln_itm->qty_dispatched, $_POST['Location'], $_POST['DispatchDate'], get_post('batch_no'.$line)))
			$qty = $check['qty'];

// display_error($qty);
		$q_class =  hook_get_dispatchable_quantity($ln_itm, $_POST['Location'], $_POST['DispatchDate'], $qty);

		// Skip line if needed
		if($q_class === 'skip')  continue;
		if(is_array($q_class)) {
		  list($ln_itm->qty_dispatched, $row_classes) = $q_class;
			$has_marked = true;
		}
	}

	alt_table_row_color($k, $row_classes);
	view_stock_status_cell($ln_itm->stock_id);

	if ($ln_itm->descr_editable)
		text_cells(null, 'Line'.$line.'Desc', $ln_itm->item_description, 30, 50);
	else
		label_cell($ln_itm->item_description);

	$dec = get_qty_dec($ln_itm->stock_id);
	if($ln_itm->copy_line!=-1)
	label_cell(' Clone');
	else	
	qty_cell($ln_itm->quantity, false, $dec);
	label_cell(get_unit_descr($ln_itm->unit_id));
	
	if($kv_exp_date) {
		
		kv_batch_list_cells(null, 'batch_no'.$line, null, true, true, $ln_itm->stock_id, $_POST['Location'],  false, null, $_SESSION['Items']->file_system);
		if(list_updated('batch_no'.$line) || get_post('batch_no'.$line)){				
			if(get_post('batch_no'.$line) != '' || get_post('batch_no'.$line) != null ){
				$sql0 =" SELECT exp_date, SUM(qty) AS Stock FROM ".TB_PREF."stock_moves WHERE batch_no=".db_escape(get_post('batch_no'.$line))." AND stock_id=".db_escape($ln_itm->stock_id)."  AND loc_code=".db_escape($_POST['Location']) ;  
				$res = db_query($sql0, "can't execute the query");
				$row_res = db_fetch_row($res);		
				$_POST['exp_date'.$line] = sql2date($row_res[0]);	
				$_POST['qty'.$line] = $row_res[1];	
				
				hidden('exp_date'.$line, $_POST['exp_date'.$line]);
				label_cell($_POST['exp_date'.$line]);
			} else {
				date_cells(null, 'exp_date'.$line, null);
				$_POST['qty'.$line] = 0;
			}
			$Ajax->activate('items_table');
		}	else {
			$_POST['qty'.$line] = 0;
			date_cells(null, 'exp_date'.$line, null);
		}
		$ln_itm->batch_no = get_post('batch_no'.$line);
		$ln_itm->exp_date = get_post('exp_date'.$line);
	}elseif($kv_batch) {
		
		if($ln_itm->lock_line){
         label_cell($_POST['batch_no'.$line]);
         hidden('batch_no'.$line,$_POST['batch_no'.$line]);
         $lock_batch[]=db_escape($_POST['batch_no'.$line]);
		}
		else	
		kv_batch_list_cells(null, 'batch_no'.$line, null, true, false, $ln_itm->stock_id,$_POST['Location'],false,$lock_batch, $_SESSION['Items']->file_system);
		if(list_updated('batch_no'.$line) || get_post('batch_no'.$line)){				
			if(get_post('batch_no'.$line) != '' || get_post('batch_no'.$line) != null ){
				$sql0 =" SELECT SUM(qty) AS Stock FROM ".TB_PREF."stock_moves WHERE batch_no=".db_escape(get_post('batch_no'.$line))." AND stock_id=".db_escape($ln_itm->stock_id)." AND loc_code=".db_escape($_POST['Location']);  
				$sql0 .= " GROUP BY batch_no";
				// display_error(	$sql0);
				$res = db_query($sql0, "can't execute the query");
				$row_res = db_fetch_row($res);	
				if(!isset($_POST['qty'.$line]))
				$_POST['qty'.$line] = $row_res[0];
		
			} else {
				$_POST['qty'.$line] = 0;
			}
			$Ajax->activate('items_table');
		}	else {
			$_POST['qty'.$line] = 0;
		}
		$ln_itm->batch_no = get_post('batch_no'.$line);
	}
	
	
// 	display_error($ln_itm->qty_done." -- ".$ln_itm->qty_dispatched ." -- ".$_POST['qty'.$line]);
	


	if(isset($_POST['clear_quantity'])) {
		$ln_itm->qty_dispatched = 0;
	}
	//$_POST['Line'.$line]=$ln_itm->qty_dispatched; /// clear post so value displayed in the fiel is the 'new' quantity
	//small_qty_cells(null, 'Line'.$line, qty_format($ln_itm->qty_dispatched, $ln_itm->stock_id, $dec), null, null, $dec);

	$yet_to_deliver = $ln_itm->quantity - $ln_itm->qty_done; 
		// display_error(	 $ln_itm->quantity." - ".	 $ln_itm->qty_dispatched);
	$thisLine_qty = (isset($_POST['qty'.$line]) ? ($_POST['qty'.$line] > $yet_to_deliver  ? $yet_to_deliver : $_POST['qty'.$line]) : 0 );
	// display_error($_POST['qty'.$line]." ==  ".$thisLine_qty."   =======   ".$ln_itm->quantity." - ".$ln_itm->qty_dispatched);
	if(!isset($_POST['Line'.$line]) || $_POST['Line'.$line] == 0 )
		$_POST['Line'.$line]=qty_format($thisLine_qty, $ln_itm->stock_id, $dec); /// clear post so value displayed in the fiel is the 'new' quantity
	elseif(get_post('batch_no'.$line) != '' ){
		// display_error($_POST['qty'.$line]." == ".$_POST['qty'.$line])
				// display_error(input_num('qty'.$line)."   === ".input_num('Line'.$line) );
		if(input_num('qty'.$line) < input_num('Line'.$line)){
			$_POST['Line'.$line] = qty_format($_POST['qty'.$line], $ln_itm->stock_id, $dec);
			display_warning(_("You can't add more than the batch quantity"));
		}
		else{
			if(!isset($_POST['Line'.$line]) || list_updated('batch_no'.$line))
		$_POST['Line'.$line]=qty_format($thisLine_qty, $ln_itm->stock_id, $dec);	
		}
	}

		$line_qty_sum+=input_num('Line'.$line);
	if($ln_itm->copy_line!=-1)
	label_cell(' Clone( '.$line_qty_sum.' )' );
	else	
	qty_cell($ln_itm->qty_done, false, $dec);
	      $readonly='';
		if($ln_itm->lock_line)
		 $readonly='readonly';	
	small_qty_cells(null, 'Line'.$line, $_POST['Line'.$line], null, null, $dec,$readonly);

	$display_discount_percent = percent_format($ln_itm->discount_percent*100) . "%";

	$line_total = ($ln_itm->qty_dispatched * $ln_itm->price * (1 - $ln_itm->discount_percent));

	amount_cell($ln_itm->rate_type);
	amount_cell($ln_itm->rate);
	amount_cell($ln_itm->price);
	label_cell($ln_itm->tax_type_name);
	label_cell($display_discount_percent, "nowrap align=right");
	amount_cell($line_total);
    if(input_num('Line'.$line)<$yet_to_deliver && !$ln_itm->lock_line){

	if (check_negative_stock($ln_itm->stock_id, -$_POST['qty'.$line], $_POST['Location'], $_POST['DispatchDate'], get_post('batch_no'.$line)))
        label_cell("Batch N/A On ".$_POST['DispatchDate']," class='stockmankobg ' ");
		else
		check_cells(null, 'copy_line'.$line, $_POST['copy_line'.$line],
		true, _('Set this option duplicate line for different batch'));
    }
    else{
    	if (check_negative_stock($ln_itm->stock_id, -$_POST['qty'.$line], $_POST['Location'], $_POST['DispatchDate'], get_post('batch_no'.$line)))
        label_cell("Batch N/A On ".$_POST['DispatchDate']," class='stockmankobg ' ");
		else
         label_cell('-');	
    }
	$qty_total = input_num('Line'.$line);

 // 	if(input_num('copy_line'.$line)){
 // 		global   $Ajax;
 		// // display_error(count($_SESSION['Items']->line_items)." count" ) ;
 		//  $n_line= count($_SESSION['Items']->line_items);
 		//  // display_error($n_line);
   //       $_SESSION['Items']->line_items[$n_line] = $_SESSION['Items']->line_items[$line];
   //       $_SESSION['Items']->line_items[$n_line]->quantity =  $yet_to_deliver-input_num('copy_line'.$line);
   //       $_SESSION['Items']->line_items[$n_line]->qty_dispatched=0;
   //       unset($_POST['copy_line'.$line]);
   //     	$Ajax->activate('_page_body');

	// }



	// if(list_updated('batch_no'.$line))
		// $Ajax->activate( 'Line'.$line);

	end_row();
}


// echo "<pre>";
// print_r( $_SESSION['Items']->line_items);


$_POST['ChargeFreightCost'] =  get_post('ChargeFreightCost', 
	price_format($_SESSION['Items']->freight_cost));
if($kv_exp_date)
	$colspan=11;
else
$colspan = ($kv_batch ? 12 : 9 );

start_row();
label_cell(_("Shipping Cost"), "colspan=$colspan align=right");
small_amount_cells(null, 'ChargeFreightCost', $_SESSION['Items']->freight_cost);
end_row();

$inv_items_total = $_SESSION['Items']->get_items_total_dispatch();

$display_sub_total = price_format($inv_items_total + input_num('ChargeFreightCost'));

label_row(_("Sub-total"), $display_sub_total, "colspan=$colspan align=right","align=right");

$result = get_charges(check_value('show_inactive'));
$i = 1;
while ($myrow = db_fetch($result)){
	$chages_edit = charges_trans_edit(key($_SESSION['Items']->trans_no), ST_CUSTDELIVERY,
		$myrow['id']);
    start_row();
    if($myrow['is_percentage'])
    	$colspan = 10;
	else
	    $colspan = 12;

	$lbl=($myrow['is_negative'])? " (-)" : " (+)";
 	if($chages_edit['charges_amount'] && !isset($_POST['charges_amount'.$i]))
		$_POST['charges_amount'.$i] = abs($chages_edit['charges_amount']);
 
    if($myrow['is_percentage']){
 		label_cell(null,"colspan=$colspan");
    	text_cells_ex(_($myrow['name']." ".$lbl), 'percentage'.$i, 2, 255, null, null, "colspan='1' align=left", null, true);
    	// $charges_ = get_charge_is_percentage($myrow['is_percentage'], $myrow['is_weight']);
		$charges_rate_per = get_charge_rate_per_charges_id($myrow['id'], input_num('percentage'.$i));

		if($myrow['is_percentage'] == 1 && $myrow['is_weight'] == 0){
			$_POST['charges_amount'.$i] = $inv_items_total/100*input_num('percentage'.$i);
		}
		elseif($myrow['is_percentage'] == 1 && $myrow['is_weight'] == 1){
			$_POST['charges_amount'.$i] =  ($qty_total/100)*$charges_rate_per['amount'];
		}
		text_cells(null, "charges_amount".$i, price_format(input_num('charges_amount'.$i)), 15, "", false, "colspan=$colspan align=right", "", "", false);	 
    }else{
    	text_cells($myrow['name']." ".$lbl, "charges_amount".$i, price_format(input_num('charges_amount'.$i)), 15, "", false, "colspan=$colspan align=right", "", "", false);
    }
    // label_cell(null, "colspan=2", null);
     if($myrow['is_negative'])
    $inv_items_total-=input_num('charges_amount'.$i);
    else
     $inv_items_total+=input_num('charges_amount'.$i);
    end_row();
    $i++;
}

$taxes = $_SESSION['Items']->get_taxes(input_num('ChargeFreightCost'));
$tax_total = display_edit_tax_items($taxes, $colspan, $_SESSION['Items']->tax_included);

$display_total = price_format(($inv_items_total + input_num('ChargeFreightCost') + $tax_total));

label_row(_("Amount Total"), $display_total, "colspan=$colspan align=right","align=right");

end_table(1);

if ($has_marked) {
	display_note(_("Marked items have insufficient quantities in stock as on day of delivery."), 0, 1, "class='stockmankofg'");
}
start_table(TABLESTYLE2);

policy_list_row(_("Action For Balance"), "bo_policy", null);

textarea_row(_("Memo"), 'Comments', null, 50, 4);

end_table(1);
div_end();


// $id = find_submit('_copy_line');
// if ($id != -1)
// {
// // display_error($id);
// 	// global $Ajax;
	
// 	// display_error(count($_SESSION['Items']->line_items)." count" ) ;
// 	$n_line= count($_SESSION['Items']->line_items);
// 	// display_error($n_line." ".$id);
// 	$_SESSION['Items']->line_items[$n_line] = &$_SESSION['Items']->line_items[$id];
// 	$_SESSION['Items']->line_items[$n_line]->quantity =  $yet_to_deliver-input_num('copy_line'.$id);
// 	$_SESSION['Items']->line_items[$n_line]->qty_dispatched=0;
// 	unset($_POST['copy_line'.$id]);
// 	 $Ajax->activate('_page_body');

// 	}

submit_center_first('Update', _("Update"),
	_('Refresh document page'), true);
if(isset($_POST['clear_quantity'])) {
	submit('reset_quantity', _('Reset quantity'), true, _('Refresh document page'));
}
else  {
	submit('clear_quantity', _('Clear quantity'), true, _('Refresh document page'));
}
submit_center_last('process_delivery', _("Process Dispatch"),
	_('Check entered data and save document'), 'default');

end_form();


end_page();

